<?php

// Create or Update the vendor table in Management DB.
// The table is used in opengatemchk
//
// At installation, run to create vendor table
//
// After installation, run periodically to update vendor table.


//connect to Management DB (* set proper parameters *)
$link = mysql_connect("localhost", "root", "");
if (!$link) die('Cannot connect to DB.'.mysql_error());

// select opengatem database
$db_selected = mysql_select_db('opengatem', $link);
if (!$db_selected) die('Cannot select DB.'.mysql_error());

// create table if not exists
$sql = "CREATE TABLE IF NOT EXISTS nicvendors(oui CHAR(8), org TINYTEXT)";
mysql_query($sql);

// connect to oui list in IEEE site
$fp = fopen("http://standards.ieee.org/develop/regauth/oui/oui.txt", "r");
if(!$fp) die('Cannot connect to IEEE site. Check network connection');

// scan the download list
while (!feof($fp)) {

  // get one line
  $line = fgets($fp);

  // columns 0-7 may be oui 
  $oui = substr($line, 0, 8);

  //if $oui is not "**-**-**", skip the line
  if(preg_match('/^[0-9A-F]{2}-[0-9A-F]{2}-[0-9A-F]{2}$/',$oui)!=1)continue;

  // reformat $oui from "01-56-AB" to "01:56:ab"
  $oui = str_replace("-",":",$oui);
  $oui = strtolower($oui);

  // column 16- should be vendor name (trim CR code)
  $org = substr($line, 16);

  // remove CR code and quotation code
  $org = str_replace(array("\r\n","\n","\r"), "", $org);
  $org = str_replace("\"", "", $org);
  $org = str_replace("\t", "", $org);

  // insert to db
  $sql = sprintf(
    'REPLACE INTO nicvendors (oui,org) VALUES( "%s", "%s")',
    $oui, $org);
  mysql_query($sql);

  // log to console
  print $oui." ".$org."<br>\n";
}
fclose($fp);
?>

